const LIGACOES_INDEX = function () {
    let table;
    let carregarTotais = 1;
    let permitirLeads  = false;
    let urlContato     = '';

    const abrirModalNovoContato = function () {
        let telefone    = $(this).data('origem');
        let id          = $(this).data('id');
        let dataLigacao = $(this).data('dataLigacao');
        let fonte       = $(this).data('fonte');
        let modal       = $('.dtr-bs-modal');

        if (modal.hasClass('in')) {
            modal.one('hidden.bs.modal', function () {
                carregarModalNovoContato(telefone, id, dataLigacao, fonte);
            });
            modal.modal('hide');
        } else {
            carregarModalNovoContato(telefone, id, dataLigacao, fonte);
        }
    };

    const carregarModalNovoContato = function (telefone, id, dataLigacao, fonte) {
        $(document).ready(function () {
            $.ajax({
                type       : 'POST',
                url        : 'action/abrir_modal_nova_ligacao',
                data       : {
                    'telefone'    : telefone,
                    'id'          : id,
                    'dataligacao' : dataLigacao,
                    'fonte'       : fonte,
                },
                success    : function (data) {
                    $('.preloader').css({display : 'none'});

                    if (data === '-1') {
                        window.location.href = './';
                        return;
                    }

                    if (data.substring(0, 2) === '-2') {
                        toastr.clear();
                        toastr.error(data.substring(2));
                        return;
                    }

                    $('#modal-sistema-conteudo').html(data);
                    $('#modal-sistema').modal();
                },
                beforeSend : function () {
                    $('.preloader').css({display : 'block'});
                },
                complete   : function () {
                    $('.preloader').css({display : 'none'});
                },
                error      : function () {
                    $('.preloader').css({display : 'none'});
                    toastr.clear();
                    toastr.error('Houve um erro ao abrir modal.');
                },
            });
        });
    };

    const abrirModalVerContato = function () {
        let telefone = $(this).data('origem');
        let id       = $(this).data('id');
        let modal    = $('.dtr-bs-modal');

        if (modal.hasClass('in')) {
            modal.one('hidden.bs.modal', function () {
                carregarModalVerContato(telefone, id);
            });
            modal.modal('hide');
        } else {
            carregarModalVerContato(telefone, id);
        }
    };

    function carregarModalVerContato(telefone, id) {
        $(document).ready(function () {
            jQuery.ajax({
                type       : 'POST',
                url        : 'action/abrir_modal_ligacao_contato',
                data       : {
                    'telefone' : telefone,
                    'id'       : id,
                },
                success    : function (data) {
                    $('.preloader').css({display : 'none'});
                    if (data === '-1') {
                        window.location.href = './';
                        return;
                    }
                    if (data.substring(0, 2) === '-2') {
                        toastr.clear();
                        toastr.error(data.substring(2));
                        return;
                    }
                    $('#modal-sistema-conteudo').html(data);
                    $('#modal-sistema').modal();
                },
                beforeSend : function () {
                    $('.preloader').css({display : 'block'});
                },
                complete   : function () {
                    $('.preloader').css({display : 'none'});
                },
                error      : function () {
                    $('.preloader').css({display : 'none'});
                    toastr.clear();
                    toastr.error('Houve um erro ao abrir modal.');
                },
            });
        });
    }

    const abrirModalVerLigacao = function () {
        let id    = $(this).data('id');
        let modal = $('.dtr-bs-modal');

        if (modal.hasClass('in')) {
            modal.one('hidden.bs.modal', function () {
                carregarModalVerLigacao(id);
            });
            modal.modal('hide');
        } else {
            carregarModalVerLigacao(id);
        }
    };

    const carregarModalVerLigacao = function (id) {
        $(document).ready(function () {
            jQuery.ajax({
                type       : 'POST',
                url        : 'action/abrir_modal_ligacao',
                data       : {
                    'id' : id,
                },
                success    : function (data) {
                    $('.preloader').css({display : 'none'});
                    if (data === '-1') {
                        window.location.href = './';
                        return;
                    }
                    if (data.substring(0, 2) === '-2') {
                        toastr.clear();
                        toastr.error(data.substring(2));
                        return;
                    }
                    $('#modal-sistema-conteudo').html(data);
                    $('#modal-sistema').modal();
                },
                beforeSend : function () {
                    $('.preloader').css({display : 'block'});
                },
                complete   : function () {
                    $('.preloader').css({display : 'none'});
                },
                error      : function () {
                    $('.preloader').css({display : 'none'});
                    toastr.clear();
                    toastr.error('Houve um erro ao abrir modal.');
                },
            });
        });
    };

    const handleTable = function () {
        table = $('#tbLigacoes').serverTable({
            'ajax'       : {
                'url'     : 'action/atualizar_ligacoes',
                'type'    : 'POST',
                'data'    : function (data) {
                    if (carregarTotais) {
                        $('.info-box-number').html('<div class="preloader"><i class="fa fa-refresh fa-spin"></i></div>');
                        $('.preloader').css({display : 'block'});
                    } else {
                        $('.preloader:not(.filtros)').css({display : 'block'});
                    }

                    let formData = $('#formLigacoes').serializeArray();
                    $.each(formData, function (key, val) {
                        data[val.name] = val.value;
                    });
                    data['carregarTotais'] = carregarTotais;
                },
                'dataSrc' : function (response) {
                    permitirLeads = response.permitirLeads;
                    urlContato    = response.urlContato;

                    $('.preloader').css({display : 'none'});

                    if (carregarTotais === 1) {
                        carregarTotais = 0;
                        $('#totalligacoes').html(response.recordsTotal);
                        $('#totalgasto').html(response.valor);
                    }

                    return response.data;
                },
            },
            'columns'    : [
                {
                    'name'      : 'real_source',
                    'title'     : 'Origem',
                    'orderable' : false,
                },
                {
                    'name'      : 'destination',
                    'title'     : 'Destino Final',
                    'orderable' : false,
                },
                {
                    'name'      : 'source',
                    'title'     : 'Fonte',
                    'orderable' : false,
                },
                {
                    'name'        : 'start_time',
                    'title'       : 'Dia da Ligação',
                    'filter'      : 'text',
                    'filterClass' : 'mascara-data',
                    'render'      : function (data) {
                        return moment(data, 'YYYY-MM-DD HH:mm:ss').format('DD/MM/YYYY HH:mm:ss');
                    },
                },
                {
                    'name'      : 'cost',
                    'title'     : 'Custo',
                    'orderable' : false,
                },
                {
                    'name'      : 'talking_duration',
                    'title'     : 'Tempo de Conversa',
                    'orderable' : false,
                },
                {
                    'name'      : 'id',
                    'title'     : 'Opções',
                    'class'     : 'table-buttons',
                    'orderable' : false,
                    'render'    : function (data, type, row) {
                        let html = '<div class=\'btn-group\'>';

                        if (permitirLeads && row[10] === true) {
                            html += '<a href= \'javascript:void(0);\' class=\'btn btn-default text-orange botao-editar-contato\' ' +
                                'title=\'Clique editar o contato.\' data-id=\'' + data + '\' data-origem=\'' + row[0] +
                                '\'><i class=\'fa fa-edit\'></i></a>';
                        } else if (permitirLeads && row[10] === false) {
                            html += '<a href= \'javascript:void(0);\' class=\'btn btn-default text-green botao-novo-contato\' ' +
                                'title=\'Clique para adicionar como um contato.\' data-origem="' + row[0] + '" data-fonte="' +
                                row[2] + '" data-id="' + data + '" data-data-ligacao="' + row[3] + '"><i class=\'fa fa-plus\'></i></a>';
                        }

                        html += '<a href= \'javascript:void(0);\' class=\'btn btn-default text-blue botao-ver-ligacao\' ' +
                            'title=\'Clique para ver os detalhes desta ligação.\' data-id="' + data + '"><i class=\'fa fa-list\'></i></a>';

                        if (row[0].length > 3) {
                            html += '<a href="tel:0' + row[0].replace(/[`~!@#$%^&*()_ |+\-=?;:'",.<>\{\}\[\]\\\/]/gi, '') +
                                '" class="btn btn-default text-blue" title="Clique para ligar"><i class="fa fa-phone"></i></a>';
                        }

                        const telefoneFormatado = row[0].replace(/[`~!@#$%^&*()_ |+\-=?;:'",.<>\{\}\[\]\\\/]/gi, '');
                        const telefoneNormal    = row[0];

                        const urlTelefoneFormatado = urlContato.replace('#TELEFONE#', telefoneFormatado);
                        const urlTelefoneNormal    = urlContato.replace('#TELEFONE#', telefoneNormal);

                        if (row[0].indexOf('(') !== -1) {
                            html += '<a href="' + urlTelefoneFormatado + '" class="btn btn-default text-light-gold" target="_blank"' +
                                ' title="Enviar mensagem para esse número"><i class="fa fa-whatsapp"></i></a>';
                        } else {
                            html += '<a href="' + urlTelefoneNormal + '" class="btn btn-default text-light-gold" target="_blank" ' +
                                'title="Enviar mensagem para esse número"><i class="fa fa-whatsapp"></i></a>';
                        }

                        html += '</div>';

                        return html;
                    },
                },
                {
                    'name'      : 'answered',
                    'title'     : 'Atendida',
                    'orderable' : false,
                    'filter'    : [
                        {
                            'text'  : 'Atendida',
                            'value' : '1',
                        },
                        {
                            'text'  : 'Não Atendida',
                            'value' : '0',
                        },
                    ],
                    'render'    : function (data) {
                        return data === 1 ? 'Atendida' : 'Não Atendida';
                    },
                },
                {
                    'name'      : 'ringing_duration',
                    'title'     : 'Tempo de Espera',
                    'orderable' : false,
                },
                {
                    'name'      : 'total_duration',
                    'title'     : 'Duração Total',
                    'orderable' : false,
                },
                {
                    'name'    : 'adicionado',
                    'title'   : 'Adicionado',
                    'visible' : false,
                },
                {
                    'name'    : 'valido',
                    'title'   : 'Válido',
                    'visible' : false,
                },
            ],
            'order'      : [],
            'createdRow' : function (row, data) {
                $(row).addClass('id' + data[6]);

                if (data[10] === true) {
                    $(row).css('background-color', '#bafdd7');
                }

                let atendida = $('td', row).eq(7);

                if (data[7] === 1) {
                    atendida.css('color', 'green');
                } else {
                    atendida.css('color', 'red');
                }
            },
        });
    };

    const atualizarFiltro = function () {
        let valor = $('#data').val();

        if (valor === 'CUSTOM_DATE')
            $('.datadiv').removeClass('hide');
        else {
            $('.datadiv').addClass('hide');
            carregarTotais = 1;
            table.ajax.reload();
            salvarFiltro(valor, '', '');
        }
    };

    const handleFiltro = function () {
        $('#data, #switch').change(atualizarFiltro);
        $('#datapersonalizada').click(function () {
            salvarFiltro($('#data').val(), $('#datainicial').val(), $('#datafinal').val());
            carregarTotais = 1;
            table.ajax.reload();
        });
    };

    const handleButtons = function () {
        $(document).on('click', '.botao-novo-contato', abrirModalNovoContato);
        $(document).on('click', '.botao-editar-contato', abrirModalVerContato);
        $(document).on('click', '.botao-ver-ligacao', abrirModalVerLigacao);
    };

    return {
        init : function () {
            handleTable();
            handleFiltro();
            handleButtons();
        },

        recarregar : function () {
            table.ajax.reload();
        },
    };
}();

$(function () {
    LIGACOES_INDEX.init();
});

// as funções abaixo estão assim públicas para compatibilidade com o código já existente no sistema
function fechar_modal() {
    $('#modal-sistema').modal('hide');
}

function mudar_icone_adicionado() {
    LIGACOES_INDEX.recarregar();
}