<?php

namespace Win7\Application\Factory;

use Illuminate\Database\Capsule\Manager;
use Illuminate\Database\Connection;
use Psr\Container\ContainerInterface;

/**
 * @namespace Win7\Application\Factory
 * @author Thiago Daher
 */
class DbConnectionFactory implements FactoryInterface
{

    /**
     * @param \Psr\Container\ContainerInterface $container
     * @return \Illuminate\Database\Connection
     */
    public static function create(ContainerInterface $container): Connection
    {
        register_shutdown_function('closeAppConnections');
        
        return Manager::connection('default');
    }
}

function closeAppConnections(){
    \Win7\App::getContainer()->get(\Illuminate\Database\ConnectionInterface::class)->disconnect();
}